// ᨬ쭮 ⢮ -
#define MaxModVoices 8

// ᨬ ਮ
#define MaxPeriod 856
//  ਮ
#define MinPeriod 113


// MOD 䥪
enum{
 Arpeggio=0, PortamentoUp, PortamentoDown, TonePortamento, Vibrato,
 TonePortamentoPlusVolumeSlide, VibratoPlusVolumeSlide, Tremolo, Pan,
 SampleOffset, VolumeSlide, PositionJump, SetVolume, PatternBreak, ExtendedEffects,
 SetSpeed,
 // ७ 䥪
 SetFilter=0h, FinePortamentoUp, FinePortamentoDown, GlissandoControl,
 VibratoWaveForm, SetFineTune, PatternLoop, TremoloWaveForm, _16PositionPan,
 RetringNote, FineVolumeSlideUp, FineVolumeSlideDown, CutNote, NoteDelay,
 PatternDelay, InvertLoop
};



//  ୠ
struct PATTERNELEMENT
{
 byte SampleNumber;     //  ᥬ
 word NotePeriod;       // ਮ 
 byte EffectNumber;     //  䥪
 byte EffectParametr;   // ࠬ 䥪
};



//   -
struct MODVOICE
{
 word LastNotePeriod;    // ᫥ ᯮ짮訩 ਮ 
 word LastSampleNumber;  // ᫥ ᯮ짮訩 ᥬ  
 dword LastRate;         // 來 ᯮ짮  롮ન ᥬ
 dword CurrentRate;      //   롮ન ᥬ
 byte CurrentVolume;     //  ஬
// word NumSamples;        // ⢮ ⠢ 롮ப   ᥬ
 word RepeatLength;      //  横 ᥬ
 word RepeatOffs;        // 饭 横 ᥬ
 word SampleSeg;         //  ᥬ
 fixed SampleOffs;       // 饭 ᥬ
// fixed SampleDeltaOffs;  //  ᪮쪮 ᬥ  롮થ
 fixed SampleLength;     //  ᥬ
// word SampleNumber;      //  ⥪饣 ᥬ
// byte LastEffect;        //  ᫥ ᯮ짮襣 䥪
// byte LastEffectParametr; // ࠬ ᫥ ᯮ짮襣 䥪
 PATTERNELEMENT PatternElement; //  ୠ
 word ModWorkBufSeg;            //  ࠡ祣  ⥪饣 
 word ModWorkBufSampleLength;   //  ᥬ  ࠡ祬 
 byte Active;                   //  ⨢ 
 byte Cycling;                  //  横 

 // ६  䥪 Tremolo
 byte TremoloWaveFormOffs;      // 饭  ᨢ  
 byte TremoloVolume;            // ஬ 
 // ६  䥪 Vibrato
 byte VibratoEffectParametr;    // ࠬ 䥪
 byte VibratoWaveFormOffs;      // 饭  ᨢ  
 word VibratoNotePeriod;        // ਮ ⥪饩   䥪 Vibrato
 byte VibratoNegative;
 // ६  䥪 TonePortamento
 word TonePortamentoNotePeriod; // ਮ 
 byte TonePortamentoEffectParametr; // ࠬ 䥪
 // ६  䥪 Arpeggio
 byte ArpeggioIndex;            // 
 word ArpeggioFramePeriod[3];   // ਮ    
}ModVoice[MaxModVoices];


//  ந -
:byte PlayModModule=FALSE;


//  ࠡ祣 
:word ModWorkBufSize;

//  ᨭᮢ 0..360 (sin*256)
/*:char SinTable[32]={
  0, 25, 50, 74, 98,120,142,162,180,197,212,225,
236,244,250,254,255,254,250,244,236,225,212,197,
180,162,142,120,98,74,50,25};*/
:char SinTable[64]=
//{0,25,49,71,90,106,117,125,127,125,117,106,90,71,49,25,0,231,207,185,166,150,
//139,131,129,131,139,150,166,185,207,231,0,25,49,71,90,106,117,125,127,125,117,106,
//90,71,49,25,0,231,207,185,166,150,139,131,129,131,139,150,166,185,207,231};
{0,12,25,37,49,60,71,81,90,98,106,112,117,122,125,126,127,126,125,122,117,112,106,
98,90,81,71,60,49,37,25,12,0,244,231,219,207,196,185,175,166,158,150,144,139,134,
131,130,129,130,131,134,139,144,150,158,166,175,185,196,207,219,231,244};



//  ਮ  䥪 Arpeggio
:word PeriodTable[36]={
856,808,762,720,678,640,604,570,538,508,480,453,
428,404,381,360,339,320,302,285,269,254,240,226,
214,202,190,180,170,160,151,143,135,127,120,113};


// ⭮襭 SbRate/CurrentRate
:fixed SbRate_CurrentRate;
// ⭮襭 CurrentRate/SbRate
:fixed CurrentRate_SbRate;



